Gecode::Int::Cumulative::OmegaTree< TaskView > Class Template Reference

Omega trees for computing ect of task sets. More...

`#include <cumulative.hh>`

## Public Member Functions

| OmegaTree (Region &r, int c, const TaskViewArray< TaskView > &t)
| Initialize tree for tasks t and capacity c.
void | insert (int i)
| Insert task with index i.
void | remove (int i)
| Remove task with index i.
long long int | env (void) const
| Return energy envelope of all tasks.

## Protected Attributes

int | c
| Capacity.
Protected Attributes inherited from Gecode::Int::TaskTree< TaskView, OmegaNode >
const TaskViewArray< TaskView > & | tasks
| The tasks from which the tree is computed.
OmegaNode * | node
| Task nodes.
int * | _leaf
| Map task number to leaf node number in right order.

## Additional Inherited Members

Protected Member Functions inherited from Gecode::Int::TaskTree< TaskView, OmegaNode >
int | n_inner (void) const
| Return number of inner nodes.
int | n_nodes (void) const
| Return number of nodes for balanced binary tree.
bool | n_leaf (int i) const
| Whether node i is leaf.
OmegaNode & | leaf (int i)
| Return leaf for task i.
const OmegaNode & | root (void) const
| Return root node.
void | update (int i, bool l=true)
| Update tree after leaf for task i has changed (l whether i refers to a leaf).
void | init (void)
| Initialize tree after leaves have been initialized.
| TaskTree (Region &r, const TaskViewArray< TaskView > &t)
| Initialize tree for tasks t.
Static Protected Member Functions inherited from Gecode::Int::TaskTree< TaskView, OmegaNode >
static bool | n_root (int i)
| Whether node i is index of root.
static int | n_left (int i)
| Return index of left child of node i.
static bool | left (int i)
| Test whether node i is a left child.
static int | n_right (int i)
| Return index of right child of node i.
static bool | right (int i)
| Test whether node i is a right child.
static int | n_parent (int i)
| Return index of parent of node i.

## Detailed Description

template<class TaskView>
class Gecode::Int::Cumulative::OmegaTree< TaskView >

Omega trees for computing ect of task sets.

Definition at line 561 of file cumulative.hh.

## Constructor & Destructor Documentation

## OmegaTree()

template<class TaskView>

Gecode::Int::Cumulative::OmegaTree< TaskView >::OmegaTree | ( | Region & | r,
|  | int | c,
|  | const TaskViewArray< TaskView > & | t )

Initialize tree for tasks t and capacity c.

Definition at line 56 of file tree.hpp.

## Member Function Documentation

## insert()

template<class TaskView>

void Gecode::Int::Cumulative::OmegaTree< TaskView >::insert | ( | int | i | ) |

inline

Insert task with index i.

Definition at line 67 of file tree.hpp.

## remove()

template<class TaskView>

void Gecode::Int::Cumulative::OmegaTree< TaskView >::remove | ( | int | i | ) |

inline

Remove task with index i.

Definition at line 76 of file tree.hpp.

## env()

template<class TaskView>

long long int Gecode::Int::Cumulative::OmegaTree< TaskView >::env | ( | void |  | ) | const

inline

Return energy envelope of all tasks.

Definition at line 83 of file tree.hpp.

## Member Data Documentation

## c

template<class TaskView>

int Gecode::Int::Cumulative::OmegaTree< TaskView >::c

protected

Capacity.

Definition at line 569 of file cumulative.hh.

The documentation for this class was generated from the following files:

- gecode/int/cumulative.hh
- gecode/int/cumulative/tree.hpp